#include "header.h"
#define KEY_ACTION() _getch()
MEMORY mem;
STRING *dictionary;
dword dict_ptr;
__int16 dict_length;
BITFILE temp_file;
#pragma pack(1)

__int32 search_dictionary(STRING &s,dword start_index)
{
	__int32 i;
	__int16 done;
	i=(int)start_index;
	done =0;
	while(i<=(int)dict_ptr && !done) 
	{
		if(dictionary[i]==s) done=1;
		else i++;
		

	}
	if(done) return (i);
	else return -1;
}

STRING *init_dictionary(dword expected_size,MEMORY &mem)
{
  __int16 i;
  STRING *dictionary;
  dictionary=(class STRING *)mem.allocbytes(expected_size*sizeof(dictionary));
  for(i=0;i<=255;i++)	
  {
	  dictionary[i]=STRING(mem.allocbytes(1));
	  dictionary[i].addchar((byte)(i));
           
  }
  dict_ptr=255;	
  return dictionary;
}



__int16  create_dictionary(BUFFERFILE *bf)
{
   byte ch;
   int count=0,temp=0;
   __int32 previous_index,search_index;
   dword inlength;
   FILE *fp;
   fp=fopen("temp.$$$","wb");
   fclose(fp);
   temp_file.handle=_open("temp.$$$",_O_BINARY|_O_RDWR);
   init_read(bf);
   init_write(&temp_file);
   if(bf->handle==-1 || temp_file.handle==-1) return -1;
   
   inlength=(dword)_filelength(bf->handle);
      
   dictionary=init_dictionary(inlength+512,mem);
	
   dict_ptr=255;
   dictionary[dict_ptr+1]=STRING(mem.allocbytes(0));
   search_index=256;
   previous_index=256;
   printf("\n\nSTATUS: ");
   while(readbyte(bf,&ch)!=-1)
   {
       count++;
	   if( temp<((count*100)/(int)inlength))
	   {
		   temp=(count*100)/inlength;
		   printf("\r%ld %%complete",temp);  
	   }
	   dictionary[dict_ptr+1].addchar(ch); 	
	          
	  if (dictionary[dict_ptr+1].getlength()==1)
	   previous_index=ch;
	  else if((search_index=search_dictionary(dictionary[dict_ptr+1]
		   ,(dword)(previous_index+1)))==-1)
	   { 
		
		write_bits(&temp_file,(dword)(previous_index),32);
		write_bits(&temp_file,(dword)(ch),32);
		previous_index=0;
        STRING(mem.allocbytes(dictionary[dict_ptr+1].getlength()));
        dict_ptr++;
	    dictionary[dict_ptr+1]=STRING(mem.allocbytes(0));
   	
	   }
	   else previous_index=search_index;
          
   }
 if(dictionary[dict_ptr+1].getlength()>=1)
 {
  STRING(mem.allocbytes(dictionary[dict_ptr+1].getlength()));
  dict_ptr++;
  write_bits(&temp_file,(dword)(previous_index),32);
  write_bits(&temp_file,(dword)(ch),32);
 }
  dict_length=(__int16)ceil(log((double)(dict_ptr)+1.0)/log(2.0));   
  write_bit(&temp_file,-1);
  return 0;
}

__int16  compress_temp(BITFILE *bf)
{
   dword temp;
   if(temp_file.handle==-1 || bf->handle==-1) return -1;
   init_write(bf);
   init_read(&temp_file);
   write_bits(bf,(dword)(dict_length),16);
   _lseek(temp_file.handle,0,SEEK_SET);
   while(read_bits(&temp_file,&temp,32)!=0)
     write_bits(bf,temp,dict_length);
   write_bit(bf,-1);
   _close(temp_file.handle);
   return 0;
}
  
  
__int16 compress(BUFFERFILE *bf,BITFILE *out)
{
	dword inlength=(dword)_filelength(bf->handle);
    
	if(bf->handle==-1 || out->handle==-1) return -1;
	mem = MEMORY((inlength+256)*sizeof(dictionary)*2+256);
	
    
	create_dictionary(bf);
	compress_temp(out);
	mem.DMEMORY();
	return 0;
}


/*DECOMPRESSION*/

__int16 decompress(BITFILE *in,BUFFERFILE *out)
{
	int inlength;
	dword code;
    __int32 previous_index,search_index;
     int count=0,temp=0;
   
	if(in->handle==-1 || out->handle==-1) return -1;
    init_read(in);
	init_write(out);
	read_bits(in,(dword*)&dict_length,16);
	
	if(dict_length>32) 
	{
		printf("\nError: Not a valid zip file");
		printf("%lu",dict_length);
		_getch();
		return -1;
	}
	inlength=_filelength(in->handle);
	mem = MEMORY((inlength+1024)*sizeof(dictionary)*2+256);
    dictionary=init_dictionary(inlength+512,mem);

   dictionary[dict_ptr+1]=STRING(mem.allocbytes(0));
   search_index=256;
   previous_index=256;
   printf("\n\nSTATUS: ");
   while(read_bits(in,&code,(__int16)dict_length)!=0)
   {
       count++;
	   if( temp<((count*100*(__int16)dict_length)/(inlength*8)))
	   {
		   temp=(count*100*dict_length)/(inlength*8);
		   printf("\rSTATUS: %d%% completed",temp+1);
	   }
	   
	   if (code <=dict_ptr) dictionary[dict_ptr+1]+dictionary[code]; 	
	   else {printf("\nError invalid filetype %lu %lu",dict_ptr,code); exit(1);}
	
	   if (dictionary[dict_ptr+1].getlength()==1)
	   previous_index=code;
	  else if((search_index=search_dictionary(dictionary[dict_ptr+1]
		   ,(dword)(previous_index+1)))==-1)
	   { 
		  dictionary[previous_index].writetofile(out); 
		  dictionary[code].writetofile(out); 
		  STRING(mem.allocbytes(dictionary[dict_ptr+1].getlength()));
	     dict_ptr++;
	     dictionary[dict_ptr+1]=STRING(mem.allocbytes(0));
         previous_index=-1;   	   
	  }
	   else previous_index=search_index;
          
   }
  writebyte(out,12,-1);;

   return 0;


}

