#include "header.h"
#pragma pack(1)
/*Member functions of class MEMORY*/

MEMORY::MEMORY() {mem_ptr=0;}
MEMORY::MEMORY(unsigned long bytes)
{
		mem_ptr=0;
	    mem_size=bytes;
        memory=(byte*)VirtualAlloc(NULL,mem_size,MEM_COMMIT,PAGE_READWRITE);
	    if(memory==NULL)
		{
		    printf("\n\nError:Not enough virtual memory");
            _getch();
		    exit(1);
		}

}

MEMORY::DMEMORY()
{
     if(VirtualFree(memory,mem_size,MEM_DECOMMIT)==0 ||
       VirtualFree(memory,0,MEM_RELEASE)==0)
	   {
		printf("\n\nError: Memory could not be freed %d", mem_size);
		printf("\n");
		_getch();
		exit(1);
	   }
}  

byte* MEMORY::allocbytes(unsigned long bytes)
	{
		if((mem_ptr+bytes)>mem_size)
		{
			printf("\nNot enough memory..");
			printf("\nMem_size:%lu      Memory_demanded:%lu",mem_size,
				     mem_ptr+bytes+1);   
			_getch();
			exit(1);
		}
		mem_ptr=mem_ptr+bytes;
		return(&(memory[mem_ptr-bytes]));
	}

void MEMORY ::deallocbytes(dword bytes)
{
	if(mem_ptr!=0 && mem_ptr>bytes) mem_ptr=mem_ptr-bytes;
	else printf("\n\nDeallocation failed");
}
