#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<math.h>
#include<dos.h>
void transmit();    /*	    FUNCTION PROTOTYPES */
void showt();
void showr();
void main()
{
    int n,m,*rec,*tra,i,j,k,t,l,total;           //Variables to hold data
    float t1;
    clrscr();

    /*			TRANSMITTER SECTION			*/

    showt();
    printf("\nNo. of message bits:");
    scanf("%d",&n);
    m=ceil(log(n)/log(2));
    total=m+n+1;

    tra= (int *) malloc(total *sizeof(int));     //  dynamic allocation
    rec= (int *) malloc((m+1) *sizeof(int));        //  of memory

    for(i=0;i< m+1;i++)
	    rec[i]=0;

    printf("\nEnter message bits:");
    for(i=total;i>0;i--)
    {
	  t1=(log(i)/log(2));
	  if(t1==int(t) && i>0)
		 tra[i]=0;
	  else if(i!=0)
	      scanf(" %d",&tra[i]);     //Accepting message bits from user
    }

    for(i=0;i<total;i++)            //Determining the check bits
    {
	  t=pow(2,i);
	  for(j=t;j<=total;j+=2*t)
	  for(k=j;k<j+t && k<=(m+n+1);k++)
	       tra[t]=tra[t]^tra[k];
    }

    printf("\nEncoded message is:");
    for(i=total;i>0;i--)
	   printf(" %d",tra[i]);         //Display the encoded message
    transmit();                        //   and transmitting it

    randomize();            //Generate random error

    i=random(total);
    tra[i]=tra[i]^1;

    /*                  RECEIVER SECTION 			*/

    showr();
    printf("\n\n\nReceived code word is:");
    for(i=total;i>0;i--)
	 printf(" %d",tra[i]);

    l=0;
    for(i=0;i<total;i++)
    {
	 t=pow(2,i);
	 for(j=t;j<=total;j+=2*t)
	 for(k=j;k<j+t && k<=total;k++)
		rec[l]=rec[l]^tra[k];
	 l++;
    }
    i=0;
    for(j=0;j<m+1;j++)
	 i+=rec[j]*pow(2,i);
    if(i==0)
	    printf("\nThe received word is error free!");
    else
    {
	tra[i]=tra[i]^1;
	printf("\n\nThe received word has an error");
	printf(" in bit number: %d ",i);
	printf("\nPress any key to correct the error.....");
	getch();
	printf("\n\nThe corrected code word is:");
	for(i=total;i>0;i--)
	      printf(" %d",tra[i]);
    }
    printf("\n\nThe decoded word is:");
    for(i=total;i>0;i--)
    {
	  t1=log(i)/log(2);
	  if(t1==(int)t1 && i>0)
	       tra[i]=0;

	  else if(i!=0)
	       printf(" %d",tra[i]);
    }
    getch();
}

void transmit()
{
      printf("\nPress any key to transmit message.......");
      getch();
}

void showt()
{
    printf("\n\t\t\t\t\t\t\t\t-----------");
    printf("\n\t\t\t\t\t\t\t\tTRANSMITTER");
    printf("\n\t\t\t\t\t\t\t\t--------------");
}

void showr()
{
    printf("\n\t\t\t\t\t\t\t\t-----------");
    printf("\n\t\t\t\t\t\t\t\tRECEIVER");
    printf("\n\t\t\t\t\t\t\t\t------------");
}