#include <iostream.h>
#include <iomanip.h>
#include <conio.h>
#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <math.h>

#define BUFFERSIZE 1137

typedef unsigned char byte;    
typedef unsigned short word;
typedef unsigned long int dword;


typedef struct bit_file
{
 int handle;
 byte buffer[BUFFERSIZE];
 unsigned short buffer_index;
 byte char_index;
 __int16 status;
 short bytes_read;
}BITFILE;

typedef struct byte_file
{
	int handle;
	byte buffer[BUFFERSIZE];
	short buffer_index;
	__int16 status;
	unsigned short bytes_read;
}BUFFERFILE;

class MEMORY
{
private:
	byte *memory;
	public:
	
		unsigned long mem_size;
        unsigned long mem_ptr;
    
	MEMORY();
	MEMORY(unsigned long bytes);
    DMEMORY();
	byte *allocbytes(unsigned long bytes);
	void deallocbytes(unsigned long bytes);
};


class STRING
{
private:
	byte *string;
	dword strlen;
public:
    STRING();
	STRING(byte *string_ptr);
	__int16 addchar(byte num);
	void displaystring();
	void operator+(STRING &S2);
	__int16 operator==(STRING &S2);
    void operator=(STRING &S2);
	__int16 STRING::writetofile(BUFFERFILE *bf);
    dword getlength(){return strlen;}
};

__int16 getbit(byte,byte);
void setbit(byte *,byte );
__int16 read_bit(BITFILE *);
__int16 write_bit(BITFILE *,__int16);
void init_read(BITFILE*);
void init_write(BITFILE *);
__int16 write_bits(BITFILE *bf,dword num,__int16 bits);
__int16 read_bits(BITFILE *bf,dword *num,__int16 bits);

void init_read(BUFFERFILE *bf);
void init_write(BUFFERFILE *bf);
__int16 readbyte(BUFFERFILE *bf,byte *ch);
__int16 writebyte(BUFFERFILE *bf,byte ch,__int16 operation);

__int16 decompress(BITFILE *in,BUFFERFILE *out);
__int16 compress(BUFFERFILE *bf,BITFILE *out);
