#include "header.h"

STRING::STRING()
{
 
	string=NULL;
	strlen=0;
}

STRING::STRING(byte *string_ptr)
{
    string=string_ptr;
	strlen=0;
}

__int16 STRING::addchar(byte num)
{
	if(string==NULL)
	{
		cout<<endl<<"Error: String not initialized";
		return -1;
	}
	else  string[strlen++]=num;
	
	return 0;
}
 
void STRING::displaystring()
{
	dword i;
for(i=0;i<strlen;i++)
		putch(string[i]);
}

void STRING::operator+(STRING &S2)
{
	dword i;
	if(string!=NULL && S2.string!=NULL)
	for(i=0;i<S2.strlen;i++)
		string[strlen++]=S2.string[i];
	else
	
	{
		if(string==NULL)printf("\n\nPossibly dest string not initialized");
		if(S2.string==NULL) printf("\n\nPossibly source string not initialized");
		printf("\n\n strlen: %ld %ld",strlen,S2.strlen); 
		_getch();
	
		
		return ;
	}

}



__int16 STRING::operator ==(STRING &S2)
{
	dword i;
	byte done;
	if(string==NULL || S2.string==NULL)
	{
		printf("\n\nPossibly string not initialized");
		printf("\n\n strlen: %ld",strlen); 
		_getch();
		return -1;
	}
	if(strlen > S2.strlen || strlen < S2.strlen || strlen==0 || S2.strlen==0) 
		return 0;
	
	else if(strlen==S2.strlen)
	{
       i=0;
	   done =0;
	
	   while(i< strlen && !done)
	   {
		   if(string[i]!=S2.string[i]) done=1;
		   else i++;
	   }
	   
	}
	return (!done);
}



void STRING::operator=(STRING &S2)
{
	string=S2.string;
	strlen=S2.strlen;
}

__int16 STRING::writetofile(BUFFERFILE *bf)
{
	dword i;
	if(bf->status==1 || bf->handle==-1)
	{
		printf("\n\nInvalid Write");
		exit(1);
	}
	for(i=0;i<strlen;i++)
		writebyte(bf,string[i],0);
	return 0;
}

 
